<template>
  <v-container>
    <v-row>
      <v-col cols="5">
        <v-btn @click="doAdd">Add New</v-btn>
      </v-col>
      <v-col cols="7">
        <h1>Menu</h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-data-table
            :headers="headers"
            :items="menus"
            :search="search"
            :custom-filter="doSearch"
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon small class="mr-2" @click="doEdit(item.id, item.menu_type)">mdi-pencil</v-icon>
            <v-icon small @click="doDelete(item)">mdi-delete</v-icon>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <MenuForm ref="dlg" />
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import MenuForm from "../components/MenuForm";
import service from "../service/MenuService";
import {checkError404} from "../utils/util";

export default {
  name: "Menu",
  components: {
    MenuForm,
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      search: '',
      menus: [],
      menu_parent: [],
      title: null,
      headers: [
        { text: "ACTION", align: "center", value: "actions", sortable: false },
        { text: "NO.", align: "center", value: "number", sortable: false },
        { text: "TYPE", align: "left", value: "menu_type", sortable: true },
        { text: "NAME", align: "left", value: "name", sortable: true },
        { text: "PARENT NAME", align: "left", value: "parent_name", sortable: true },
        { text: "PATH", align: "left", value: "path", sortable: true },
        { text: "PATH PARAMETER", align: "left", value: "path_parameter", sortable: true },
        { text: "FORM NAME", align: "left", value: "form_app.name", sortable: true },
        { text: "FORM PATH", align: "left", value: "form_app.form", sortable: true },
        { text: "SEQ", align: "center", value: "seq", sortable: true },
        { text: "CREATE DATE", align: "center", value: "create_at", sortable: true },
        { text: "UPDATE DATE", align: "center", value: "update_at", sortable: true },
      ],
      dialogAdd: false,
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    doAdd() {
      let title = "Add New Menu"
      this.$refs.dlg.doAdd(title, false)
    },
    async doDelete(data) {
      if (!await this.$refs.dlgMsg.confirm(`Apakah Ingin Menghapus Data MENU ${data.id} - ${data.name}`)) {
        return false;
      }
      this.statusProgress = true
      await service.delete(data.id, data.menu_type).then(async res => {
        let {status, message} = res.data
        if (status === 'SUCCESS') {
          await this.doRefresh()
        }
        this.$refs.dlgMsg.doOpenMsg(message)
      }).catch(ex => {
        checkError404(ex, this.$refs.dlgMsg)
      })
      this.statusProgress = false
    },
    doEdit(id, menu_type) {
      let title = "Edit Menu"
      let dataPk = {
        id: id,
        menu_type: menu_type
      }
      this.$refs.dlg.doEdit(dataPk, title, true)
    },
    async doLoadMenuParents() {
      this.menu_parent = []
      await service.getAll().then(resp => {
        let {data} = resp
        let menus = data.data
        for (let menu of menus) {
          if (menu.parent_id == null && menu) {
            let data_m = {
              id: menu.id,
              name: menu.name
            }
            this.menu_parent.push(data_m)
          }
        }
      })
    },
    async doRefresh() {
      this.menus = []
      await service.getAll().then(resp => {
        let status = resp.data.status
        if (status === 'SUCCESS') {
          this.menus = resp.data.data
          let number = 1;
          for (let menus of this.menus) {
            menus.number = number++
            menus.name = menus.name != null ? menus.name : '-'
            menus.parent_name = '-'
            if (menus.parent_id != null) {
              for (let menu_parent of this.menu_parent) {
                if (menus.parent_id === menu_parent.id) {
                  menus.parent_name = menu_parent.name
                }
              }
            }
            menus.path = menus.path != null ? menus.path : '-'
            menus.path_parameter = menus.path_parameter != null ? menus.path_parameter : '-'
            if (menus.form_app == null) {
              menus.form_app = {
                name: '-',
                form: '-',
              }
            } else {
              menus.form_app.name = menus.form_app.name != null ? menus.form_app.name : '-'
              menus.form_app.form = menus.form_app.form != null ? menus.form_app.form : '-'
            }
            menus.update_at = menus.update_at != null ? menus.update_at : '-'
          }
        }
      }).catch(ex => {
        checkError404(ex, this.$refs.dlgMsg)
      })
    }
  },
  async mounted() {
    this.statusProgress = true
    await this.doLoadMenuParents()
    await this.doRefresh()
    this.statusProgress = false
  }
}
</script>

<style scoped>

</style>